/*jslint browser: true*/
/*global $, jQuery, alert*/

(function () {
  'use strict';
   // this function is strict...
}());

//DECLARACION DE VARIABLES PUBLICAS NECESARIAS PARA EJECUTAR LAS FUNCIONES
var PAB, ACTABLA, RECARGAR, CACHE;
// FUNCION QUE SE EJECUTA CADA VEZ QUE SE INICIA UNA PETICION AJAX
// $(document).on({
//   ajaxStart: function () { 'use strict'; $(".loadingWait").css("display", "block"); },
//   ajaxStop: function () { 'use strict';  $(".loadingWait").css("display", "none"); }
// });
$(document).on({
  ajaxStart: function () { 'use strict'; $(".animationText").css("display", "block"); },
  ajaxStop: function () { 'use strict';  $(".animationText").css("display", "none"); }
});

// DEFINICION DE LOS PARAMETROS DE LA TABLA
var tabla = $('#tablaPB').DataTable({
  info: false,
  ordering: false,
  searching: false,
  paging: false,
  lengthMenu: [[36, -1], [36]],
  language:
     {"zeroRecords": " "},
  "autoWidth": false,
  "columnDefs": [
    { "width": "3%",  "targets": 0 },
    //{ "responsivePriority": -1, "targets": 0 },
    { "width": "2%",  "targets": 1 },
    { "width": "15%",  "targets": 2 },
    { "width": "22%", "targets": 3 },
    { "width": "3%",  "targets": 4 },
    { "width": "15%", "targets": 5 },
    { "width": "5%", "targets": 6 },
    { "width": "4%", "targets": 7 },
    { "width": "4%",  "targets": 8 },
    { "width": "3%",  "targets": 9 },
    { "width": "2%",  "targets": 10 },
    { "width": "22%",  "targets": 11 }
  ]
});

try {
  PAB = sessionStorage.getItem("PAB");
  if (PAB !== null) {
    llenarTabla(PAB);
  }
} catch (e) { console.log(e); }

// SE EJECUTA AL INICIO DE CADA PETICION AJAX
function detenerIntervalos() {
  'use strict';
  if (ACTABLA) { clearInterval(ACTABLA); }
}
// Agrega el color rojo de fondo a los pacientes aislados
function marcarAislados() {
  'use strict';
  var aisladas = $("div.aislar").parents('tr').addClass("bg-lightRed");
}

//FUNCION PARA CARGAR EL LISTADO DE PABELLONES
function getPabellones() {
  'use strict';
  $.ajax({
    type: "GET",
    url: "code/codPabellon.php",
    data: {codSede: '001'},
    contentType: "application/json; charset=utf-8",
    dataType: 'json',
    cache: false,
    success: function (pabs) {
      $.each(pabs, function (_, p) {
        $("#select-pb").append('<option value="'+p.codigoP+'">'+p.nombreP+'</option>');
      });
    }
  });
}

//FUNCION ENCARGADA DE POBLAR LA TABLA CON LOS REGISTROS ENCONTRADOS DE ACUERDO AL PABELLON SELECCIONADO
function llenarTabla(cp) {
  'use strict';
  if (cp === undefined) {
    cp = sessionStorage.getItem("PAB");
  }
  $.ajax({
    type: "GET",
    url: "code/pabellones.php",
    data: {codPabellon: cp},
    contentType: "application/json; charset=utf-8",
    dataType: 'json',
    cache: false,
    success: function (pte) {
      // console.log(pte);
      if (CACHE === pte) {
        console.log("Cache igual");
        return;
      } else {
        detenerIntervalos();
        CACHE = pte;
        var pabellon = [];
        var scHeight = window.innerHeight - 90;
        var tdHeight = scHeight / pte.length;
        var imgSize = (tdHeight<256) ? tdHeight-6 : 250;
        $.each(pte, function () {
          var p = this;
          if (p.aislado) {
            p.cama = "<div class='aislar'>" + p.cama + "</div>";
          } else {
            p.cama = "<div>" + p.cama + "</div>";
          }
          if (p.dias < 1) {
            p.dias = "";
          }
          if (p.fechaN == 1 && !p.aislado) {
            p.dias = "<table class='b-box'><tr><td class='b-text'>"+p.dias+"</td><td class='b-img'><img src='icos/birthday.png' height='"+(imgSize)+"' width='"+(imgSize)+"' /></td></tr></table>"
          }else if (p.fechaN == 1 && p.aislado) {
            p.dias = "<table class='b-box'><tr class='bg-lightRed'><td class='b-text'>"+p.dias+"</td><td class='b-img'><img src='icos/birthday.png' height='"+(imgSize)+"' width='"+(imgSize)+"' /></td></tr></table>"
          }
          if (p.esp !== null) {
            p.esp = "<div class='esp'>" + p.esp + "</div>";
          } else {
            p.esp = "";
          }
          if (p.eps === null) {
            p.eps = "";
          } else {
            p.eps = "<div class='celdaEps'>" + p.eps + "</div>";
          }
          switch (p.procqx) {
            case 'SI': p.procqx = "<img src='icos/proqx.png' height='"+imgSize+"' width='"+imgSize+"' />";
              break;
            case 'NO': p.procqx = "";
            break;
          }
          p.inter = "<div class='celdaInt'>" + p.inter + "</div>";

          // COMPRUEBA LOS ESTADOS DE RIESGOS DEL PACIENTE
          if (p.riesgoCaida === 1) {
            p.riesgoCaida = "<td class='celdariesgos bg-lightOrange'></td>";
          } else {
            p.riesgoCaida = "";
          }
          if (p.riesgoAl_Psi === 1) {
            p.riesgoAl_Psi = "<td class='celdariesgos bg-lightCrimson'></td>";
          } else {
            p.riesgoAl_Psi = "";
          }
          if (p.riesgoUlxPre === 1) {
            p.riesgoUlxPre = "<td class='celdariesgos bg-lightIndigo'></td>";
          } else {
            p.riesgoUlxPre = "";
          }
          var riesgos = "<table class='tablariesgos'><tr class='filariesgos'>" + p.riesgoCaida + p.riesgoAl_Psi + p.riesgoUlxPre + "</tr></table>";
          p.rem = (p.rem) ? "<img src='icos/rem.png' height='"+imgSize+"' width='"+imgSize+"' />" : "";
          p.scasa = (p.scasa) ? "<img src='icos/scas.png' height='"+imgSize+"' width='"+imgSize+"' />" : "";

          switch (p.alta) {
          case 0: p.alta = "";
            break;
          case 1:
            if (p.est === 1) {
              p.alta = "<img src='icos/si.png' height='"+imgSize+"' width='"+imgSize+"' />";
            } else {
              p.alta = "";
            }
            break;
          }
          switch (p.est) {
            case 0: p.est = "<img src='icos/libre.png' height='"+imgSize+"' width='"+imgSize+"' />";
            break;
            case 1: p.est = "<img src='icos/ocupada.png' height='"+imgSize+"' width='"+imgSize+"' />";
            break;
            case 8: p.est = "<img src='icos/mantenimiento.png' height='"+imgSize+"' width='"+imgSize+"' />";
            break;
            case 9: p.est = "<img src='icos/desinfeccion.png' height='"+imgSize+"' width='"+imgSize+"' />";
              (p.hora !== null ) ? p.alta = "<div class='celdaHora'>" + p.hora.substring(0, 5) + "</div>" : '';
            break;
            case 10: p.est = "<img src='icos/reservada.png' height='"+imgSize+"' width='"+imgSize+"' />";
            break;
          }
          // HORA ULTIMO FOLIO MEDICO
          p.hfm = "<div class='hfm'>" + p.hfm.substring(0, 16) + "</div>"
          pabellon.push([p.cama, p.dias, p.esp, p.eps, p.procqx, p.inter, riesgos, p.rem, p.scasa, p.alta, p.est, p.hfm]);
        }); // Fin Ciclo

        // Limpia la tabla
        tabla.clear().rows.add(pabellon).draw();
        // Ejecuta la funcion para marcar las camas aisladas
        marcarAislados();
        ACTABLA = setInterval(function () { llenarTabla(); }, 60000);
      }
      $("#tablaPB tbody tr td").css('height', tdHeight);
    }
  });
}

// FUNCION PARA REFRESCAR LA PAGINA
// function refrescar() {
//   detenerIntervalos();
//   location.reload();
// }
// REFRESCA LA PAGINA CADA CIERTO TIEMPO
// RECARGAR = setInterval( function(){ refrescar(); }, 1800000);

// EVENTO QUE OCURRE UNA VEZ HA TERMINADO DE CARGAR LA PAGINA
$(document).ready(function () {
  // EVENTO QUE SUCEDE AL SELECCIONAR UN OBJETO DE LA LISTA DESPLEGABLE
  'use strict';
  getPabellones();
  $("#select-pb").change(function () {
    var cp = $("#select-pb").val();
    if (typeof (Storage) !== undefined) {
      sessionStorage.setItem("PAB", cp);
    }
    llenarTabla(cp);
  });
}); // FIN READY
